Index: code/branches/notifications/data/gui/scripts/SheetManager.lua
===================================================================
--- code/branches/notifications/data/gui/scripts/SheetManager.lua	(revision 7340)
+++ code/branches/notifications/data/gui/scripts/SheetManager.lua	(revision 7341)
@@ -210,5 +210,5 @@
 
     -- If the first sheet that needs input is the MainMenu.
-    if counter > 0 and activeMenuSheets.size == counter and activeMenuSheets[counter].sheet.name == "MainMenu" then
+    if counter == 1 and activeMenuSheets[1].sheet.name == "MainMenu" then
         orxonox.execute("exit")
     -- If there is at least one sheet that needs input.
Index: code/branches/notifications/src/modules/notifications/NotificationManager.cc
===================================================================
--- code/branches/notifications/src/modules/notifications/NotificationManager.cc	(revision 7340)
+++ code/branches/notifications/src/modules/notifications/NotificationManager.cc	(revision 7341)
@@ -61,8 +61,11 @@
         this->highestIndex_ = 0;
 
-        //TODO: What if no graphics?
-        GUIManager::getInstance().loadGUI("NotificationLayer");
-        // Create first queue:
-        NotificationQueue* queue = new NotificationQueue("general");
+        if(GameMode::showsGraphics())
+        {
+            GUIManager::getInstance().loadGUI("NotificationLayer");
+
+            // Create first queue:
+            NotificationQueue* queue = new NotificationQueue("all");
+        }
     }
 
@@ -94,19 +97,19 @@
         this->allNotificationsList_.insert(std::pair<std::time_t,Notification*>(time,notification));
 
-        if(notification->getSender() == NONE) //!< If the sender has no specific name, then the Notification is only added to the list of all Notifications.
+        if(notification->getSender() == NONE) // If the sender has no specific name, then the Notification is only added to the list of all Notifications.
             return true;
 
         bool all = false;
-        if(notification->getSender() == ALL) //!< If all are the sender, then the Notifications is added to every NotificationListener.
+        if(notification->getSender() == ALL) // If all are the sender, then the Notifications is added to every NotificationListener.
             all = true;
 
-        //!< Insert the notification in all listeners that have its sender as target.
-        for(std::map<NotificationListener*,int>::iterator it = this->listenerList_.begin(); it != this->listenerList_.end(); it++) //!< Iterate through all listeners.
+        // Insert the notification in all listeners that have its sender as target.
+        for(std::map<NotificationListener*,int>::iterator it = this->listenerList_.begin(); it != this->listenerList_.end(); it++) // Iterate through all listeners.
         {
             std::set<std::string> set = it->first->getTargetsSet();
             if(all || set.find(notification->getSender()) != set.end() || set.find(ALL) != set.end()) //TODO: Make sure this works.
             {
-                this->notificationLists_[it->second]->insert(std::pair<std::time_t,Notification*>(time,notification)); //!< Insert the Notification in the Notifications list of the current NotificationListener.
-                it->first->update(notification, time); //!< Update the listener.
+                this->notificationLists_[it->second]->insert(std::pair<std::time_t,Notification*>(time,notification)); // Insert the Notification in the Notifications list of the current NotificationListener.
+                it->first->update(notification, time); // Update the listener.
                 std::map<Notification*, unsigned int>::iterator counterIt = this->listenerCounter_.find(notification);
                 if(counterIt == this->listenerCounter_.end())
@@ -160,4 +163,5 @@
         Returns true if successful.
     */
+    //TODO: Needed?
     bool NotificationManager::removeNotification(Notification* notification, std::multimap<std::time_t, Notification*>& map)
     {
@@ -188,9 +192,9 @@
         int index = this->highestIndex_;
 
-        this->listenerList_[listener] = index; //!< Add the NotificationListener to the list of listeners.
+        this->listenerList_[listener] = index; // Add the NotificationListener to the list of listeners.
 
         std::set<std::string> set = listener->getTargetsSet(); //TODO: Does this work?
 
-        //! If all senders are the target of the listener, then the list of notification for that specific listener is te same as the list of all Notifications.
+        // If all senders are the target of the listener, then the list of notification for that specific listener is te same as the list of all Notifications.
         if(set.find(ALL) != set.end())
         {
@@ -203,8 +207,8 @@
         std::multimap<std::time_t,Notification*> map = *this->notificationLists_[index];
 
-        //! Iterate through all Notifications to determine whether any of them should belong to the newly registered NotificationListener.
+        // Iterate through all Notifications to determine whether any of them should belong to the newly registered NotificationListener.
         for(std::multimap<std::time_t,Notification*>::iterator it = this->allNotificationsList_.begin(); it != this->allNotificationsList_.end(); it++)
         {
-            if(set.find(it->second->getSender()) != set.end()) //!< Checks whether the overlay has the sender of the current notification as target.
+            if(set.find(it->second->getSender()) != set.end()) // Checks whether the overlay has the sender of the current notification as target.
             {
                 map.insert(std::pair<std::time_t, Notification*>(it->first, it->second));
@@ -217,5 +221,5 @@
         }
 
-        listener->update(); //!< Update the listener.
+        listener->update(); // Update the listener.
 
         COUT(4) << "NotificationListener registered with the NotificationManager." << std::endl;
@@ -272,7 +276,7 @@
             return false;
 
-        std::multimap<std::time_t,Notification*>* notifications = this->notificationLists_[this->listenerList_[listener]]; //!< The Notifications for the input NotificationListener.
-
-        if(notifications == NULL) //!< Returns NULL, if there are no Notifications.
+        std::multimap<std::time_t,Notification*>* notifications = this->notificationLists_[this->listenerList_[listener]]; // The Notifications for the input NotificationListener.
+
+        if(notifications == NULL) // Returns NULL, if there are no Notifications.
             return true;
 
@@ -281,7 +285,7 @@
         itHighest = notifications->upper_bound(timeFrameStart);
 
-        for(it = itLowest; it != itHighest; it++) //!< Iterate through the Notifications from the start of the time Frame to the end of it.
-        {
-            map->insert(std::pair<std::time_t,Notification*>(it->first,it->second)); //!< Add the found Notifications to the map.
+        for(it = itLowest; it != itHighest; it++) // Iterate through the Notifications from the start of the time Frame to the end of it.
+        {
+            map->insert(std::pair<std::time_t,Notification*>(it->first,it->second)); // Add the found Notifications to the map.
         }
 