Index: code/branches/notifications/src/libraries/core/GUIManager.cc
===================================================================
--- code/branches/notifications/src/libraries/core/GUIManager.cc	(revision 7341)
+++ code/branches/notifications/src/libraries/core/GUIManager.cc	(revision 7342)
@@ -237,4 +237,6 @@
     @param name
         The name of the GUI
+    @param bNoInput
+        If true the GUI is transparent to input.
 
         The function executes the Lua function with the same name in case the GUIManager is ready.
Index: code/branches/notifications/src/modules/notifications/NotificationQueue.cc
===================================================================
--- code/branches/notifications/src/modules/notifications/NotificationQueue.cc	(revision 7341)
+++ code/branches/notifications/src/modules/notifications/NotificationQueue.cc	(revision 7342)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file NotificationQueue.cc
     @brief Implementation of the NotificationQueue class.
 */
@@ -34,18 +34,16 @@
 #include "NotificationQueue.h"
 
+#include <algorithm>
+
 #include "util/Convert.h"
 #include "core/CoreIncludes.h"
-#include "core/XMLPort.h"
-#include "Notification.h"
 #include "core/GUIManager.h"
 #include "core/LuaState.h"
-#include <algorithm>
+#include "Notification.h"
 
 namespace orxonox
 {
 
-    const std::string NotificationQueue::DEFAULT_FONT("VeraMono");
     const Vector2 NotificationQueue::DEFAULT_POSITION(0.0,0.0);
-    const float NotificationQueue::DEFAULT_FONT_SIZE = 0.025f;
 
     /**
@@ -53,5 +51,5 @@
         Constructor. Creates and initializes the object.
     */
-    NotificationQueue::NotificationQueue(const std::string& name, const std::string& senders, unsigned int size, const Vector2& position, unsigned int length, unsigned int displayTime)
+    NotificationQueue::NotificationQueue(const std::string& name, const std::string& senders, unsigned int size, const Vector2& position, unsigned int displayTime)
     {
         this->registered_ = false;
@@ -65,8 +63,8 @@
         this->maxSize_ = size;
         this->position_ = position;
-        this->notificationLength_ = length;
         this->setDisplayTime(displayTime);
 
         this->create();
+        this->positionChanged();
 
         NotificationManager::getInstance().registerListener(this);
@@ -101,11 +99,10 @@
 
     /**
-    //TODO: Document.
+    @brief
+        Creates the NotificationQueue in lua.
     */
     void NotificationQueue::create(void)
     {
-        //TODO: Also transfer font and fontsize.
         GUIManager::getInstance().getLuaState()->doString("NotificationLayer.createQueue(\"" + this->getName() + "\", " + multi_cast<std::string>(this->getMaxSize()) + ")");
-        this->positionChanged();
     }
 
@@ -118,11 +115,11 @@
     void NotificationQueue::tick(float dt)
     {
-        this->tickTime_ += dt; //!< Add the time interval that has passed to the time counter.
-        if(this->tickTime_ >= 1.0) //!< If the time counter is greater than 1s all Notifications that have expired are removed, if it is smaller we wait to the next tick.
-        {
-            this->timeLimit_.time = std::time(0)-this->displayTime_; //!< Container containig the current time.
+        this->tickTime_ += dt; // Add the time interval that has passed to the time counter.
+        if(this->tickTime_ >= 1.0) // If the time counter is greater than 1s all Notifications that have expired are removed, if it is smaller we wait to the next tick.
+        {
+            this->timeLimit_.time = std::time(0)-this->displayTime_; // Container containig the current time.
 
             std::multiset<NotificationContainer*, NotificationContainerCompare>::iterator it = this->ordering_.begin();
-            while(it != this->ordering_.upper_bound(&this->timeLimit_)) //!< Iterate through all elements whose creation time is smaller than the current time minus the display time.
+            while(it != this->ordering_.upper_bound(&this->timeLimit_)) // Iterate through all elements whose creation time is smaller than the current time minus the display time.
             {
                 NotificationContainer* temp = *it;
@@ -131,5 +128,5 @@
             }
 
-            this->tickTime_ = this->tickTime_ - (int)this->tickTime_; //!< Reset time counter.
+            this->tickTime_ = this->tickTime_ - (int)this->tickTime_; // Reset time counter.
         }
     }
@@ -138,5 +135,5 @@
     @brief
         Updates the NotificationQueue.
-        Updates by clearing the queue and requesting all relevant Notifications from the NotificationManager and inserting the in the queue.
+        Updates by clearing the queue and requesting all relevant Notifications from the NotificationManager and inserting them into the queue.
     */
     void NotificationQueue::update(void)
@@ -145,5 +142,5 @@
 
         std::multimap<std::time_t, Notification*>* notifications = new std::multimap<std::time_t, Notification*>;
-        if(!NotificationManager::getInstance().getNotifications(this, notifications, this->displayTime_)) //!< Get the Notifications sent in the interval form now to minus the display time.
+        if(!NotificationManager::getInstance().getNotifications(this, notifications, this->displayTime_)) // Get the Notifications sent in the interval form now to minus the display time.
         {
             COUT(1) << "NotificationQueue update failed due to undetermined cause." << std::endl;
@@ -154,5 +151,5 @@
             return;
 
-        for(std::multimap<std::time_t, Notification*>::iterator it = notifications->begin(); it != notifications->end(); it++) //!> Add all Notifications.
+        for(std::multimap<std::time_t, Notification*>::iterator it = notifications->begin(); it != notifications->end(); it++) // Add all Notifications.
             this->push(it->second, it->first);
 
@@ -179,4 +176,78 @@
     /**
     @brief
+        Adds a Notification, to the queue.
+        It inserts it into the storage containers, creates a corresponding container and pushes the Notification message to the GUI.
+    @param notification
+        The Notification.
+    @param time
+        The time.
+    */
+    void NotificationQueue::push(Notification* notification, const std::time_t & time)
+    {
+        NotificationContainer* container = new NotificationContainer;
+        container->notification = notification;
+        container->time = time;
+
+        // If the maximum size of the NotificationQueue has been reached the last (least recently added) Notification is removed.
+        if(this->getSize() >= this->getMaxSize())
+            this->pop();
+
+        this->size_++;
+
+        this->ordering_.insert(container);
+        this->notifications_.insert(this->notifications_.begin(), container);
+
+        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.pushNotification(\"" + this->getName() + "\", \"" + notification->getMessage() + "\")");
+    }
+
+    /**
+    @brief
+        Removes the least recently added Notification form the NotificationQueue.
+    */
+    void NotificationQueue::pop(void)
+    {
+        NotificationContainer* container = this->notifications_.back();
+        this->ordering_.erase(container);
+        this->notifications_.pop_back();
+        this->size_--;
+        delete container;
+        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.popNotification(\"" + this->getName() + "\")");
+    }
+
+    /**
+    @brief
+        Removes the Notification that is stored in the input container.
+    @param container
+        The NotificationContainer with the Notification to be removed.
+    */
+    void NotificationQueue::remove(NotificationContainer* container)
+    {
+        std::vector<NotificationContainer*>::iterator it = std::find(this->notifications_.begin(), this->notifications_.end(), container);
+        std::vector<NotificationContainer*>::difference_type index = it - this->notifications_.begin ();
+        this->ordering_.erase(container);
+        this->notifications_.erase(it);
+        this->size_--;
+        delete container;
+        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.removeNotification(\"" + this->getName() + "\", " + multi_cast<std::string>(index) + ")");
+    }
+
+    /**
+    @brief
+        Clears the queue by removing all containers.
+    */
+    void NotificationQueue::clear(void)
+    {
+        this->ordering_.clear();
+        for(std::vector<NotificationContainer*>::iterator it = this->notifications_.begin(); it != this->notifications_.end(); it++)
+        {
+            delete *it;
+        }
+        this->notifications_.clear();
+        this->size_ = 0;
+        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.clearQueue(\"" + this->getName() + "\")");
+    }
+
+    /**
+    @brief
         Sets the name of the NotificationQueue.
     @param name
@@ -203,18 +274,4 @@
     {
         this->maxSize_ = size;
-        this->update();
-    }
-
-    /**
-    @brief
-        Sets the maximum number of characters a Notification message displayed by this queue is allowed to have.
-    @param length
-        The length to be set.
-    @return
-        Returns true if successful.
-    */
-    void NotificationQueue::setNotificationLength(unsigned int length)
-    {
-        this->notificationLength_ = length;
         this->update();
     }
@@ -299,34 +356,4 @@
     /**
     @brief
-        Sets the font size.
-    @param size
-        The font size.
-    @return
-        Returns true if successful.
-    */
-    bool NotificationQueue::setFontSize(float size)
-    {
-        if(size <= 0)
-            return false;
-        
-        return true;
-    }
-
-    /**
-    @brief
-        Sets the font.
-    @param font
-        The font.
-    @return
-        Returns true if successful.
-    */
-    bool NotificationQueue::setFont(const std::string & font)
-    {
-        
-        return true;
-    }
-
-    /**
-    @brief
         Aligns all the Notifications to the position of the NotificationQueue.
     */
@@ -336,78 +363,3 @@
     }
 
-    /**
-    @brief
-        Adds a Notification, to the queue.
-        It inserts it into the storage containers, creates a corresponding container and pushes the Notification message to the GUI.
-    @param notification
-        The Notification.
-    @param time
-        The time.
-    */
-    void NotificationQueue::push(Notification* notification, const std::time_t & time)
-    {
-        NotificationContainer* container = new NotificationContainer;
-        container->notification = notification;
-        container->time = time;
-        
-        // If the maximum size of the NotificationQueue has been reached the last (least recently added) Notification is removed.
-        if(this->getSize() >= this->getMaxSize())
-            this->pop();
-
-        this->size_++;
-
-        this->ordering_.insert(container);
-        this->notifications_.insert(this->notifications_.begin(), container);
-
-        //TODO: Clip message if necessary.
-        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.pushNotification(\"" + this->getName() + "\", \"" + notification->getMessage() + "\")");
-    }
-
-    /**
-    @brief
-        Removes the least recently added Notification form the NotificationQueue.
-    */
-    void NotificationQueue::pop(void)
-    {
-        NotificationContainer* container = this->notifications_.back();
-        this->ordering_.erase(container);
-        this->notifications_.pop_back();
-        this->size_--;
-        delete container;
-        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.popNotification(\"" + this->getName() + "\")");
-    }
-
-    /**
-    @brief
-        Removes the Notification that is stored in the input container.
-    @param container
-        The NotificationContainer with the Notification to be removed.
-    */
-    void NotificationQueue::remove(NotificationContainer* container)
-    {
-        std::vector<NotificationContainer*>::iterator it = std::find(this->notifications_.begin(), this->notifications_.end(), container);
-        std::vector<NotificationContainer*>::difference_type index = it - this->notifications_.begin ();
-        this->ordering_.erase(container);
-        this->notifications_.erase(it);
-        this->size_--;
-        delete container;
-        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.removeNotification(\"" + this->getName() + "\", " + multi_cast<std::string>(index) + ")");
-    }
-
-    /**
-    @brief
-        Clears the queue by removing all containers.
-    */
-    void NotificationQueue::clear(void)
-    {
-        this->ordering_.clear();
-        for(std::vector<NotificationContainer*>::iterator it = this->notifications_.begin(); it != this->notifications_.end(); it++)
-        {
-            delete *it;
-        }
-        this->notifications_.clear();
-        this->size_ = 0;
-        GUIManager::getInstance().getLuaState()->doString("NotificationLayer.clearQueue(\"" + this->getName() + "\")");
-    }
-
 }
Index: code/branches/notifications/src/modules/notifications/NotificationQueue.h
===================================================================
--- code/branches/notifications/src/modules/notifications/NotificationQueue.h	(revision 7341)
+++ code/branches/notifications/src/modules/notifications/NotificationQueue.h	(revision 7342)
@@ -76,5 +76,5 @@
 
         public:
-            NotificationQueue(const std::string& name, const std::string& senders = NotificationManager::ALL, unsigned int size = NotificationQueue::DEFAULT_SIZE, const Vector2& position = NotificationQueue::DEFAULT_POSITION, unsigned int length = NotificationQueue::DEFAULT_LENGTH, unsigned int displayTime = NotificationQueue::DEFAULT_DISPLAY_TIME);
+            NotificationQueue(const std::string& name, const std::string& senders = NotificationManager::ALL, unsigned int size = NotificationQueue::DEFAULT_SIZE, const Vector2& position = NotificationQueue::DEFAULT_POSITION, unsigned int displayTime = NotificationQueue::DEFAULT_DISPLAY_TIME);
             virtual ~NotificationQueue();
 
@@ -104,10 +104,4 @@
                 { return this->size_; }
             /**
-            @brief Returns the maximum length in characters a Notification message is allowed to have.
-            @return Returns the maximum Notification length.
-            */
-            inline unsigned int getNotificationLength() const
-                { return this->notificationLength_; }
-            /**
             @brief Returns the time interval the Notification is displayed.
             @return Returns the display time.
@@ -121,16 +115,4 @@
             inline const Vector2 & getPosition() const
                 { return this->position_; }
-            /**
-            @brief Returns the font size used to display the Notifications.
-            @return  Returns the font size.
-            */
-            inline float getFontSize() const
-                { return this->fontSize_; }
-            /**
-            @brief Returns the font used to display the Notifications.
-            @return Returns the font.
-            */
-            inline const std::string & getFont() const
-                { return this->font_; }
 
             /**
@@ -151,9 +133,6 @@
         private:
             static const unsigned int DEFAULT_SIZE = 5; //!< The default maximum number of Notifications displayed.
-            static const unsigned int DEFAULT_LENGTH = 64; //!< The default maximum number of characters displayed.
             static const unsigned int DEFAULT_DISPLAY_TIME = 30; //!< The default display time.
-            static const float DEFAULT_FONT_SIZE; //!< The default font size.
 
-            static const std::string DEFAULT_FONT; //!< The default font.
             static const Vector2 DEFAULT_POSITION; //!< the default position.
 
@@ -167,7 +146,4 @@
 
             std::set<std::string> targets_; //!< The targets the Queue displays Notifications of.
-
-            float fontSize_; //!< The font size.
-            std::string font_; //!< The font.
 
             std::multiset<NotificationContainer*, NotificationContainerCompare> ordering_; //!< Multiset, because the ordering is based on, not necessarily unique, timestamps. //TODO: Would set work as well?
@@ -185,11 +161,7 @@
 
             void setMaxSize(unsigned int size); //!< Sets the maximum number of displayed Notifications.
-            void setNotificationLength(unsigned int length); //!< Sets the maximum number of characters a Notification message displayed by this queue is allowed to have.
             void setDisplayTime(unsigned int time); //!< Sets the maximum number of seconds a Notification is displayed.
 
             bool setTargets(const std::string & targets); //!< Set the targets of this queue.
-
-            bool setFontSize(float size); //!< Set the font size.
-            bool setFont(const std::string & font); //!< Set the font.
 
             void positionChanged(void); //!< Aligns all the Notifications to the position of the NotificationQueue.