Index: code/branches/notifications/src/modules/questsystem/Quest.cc
===================================================================
--- code/branches/notifications/src/modules/questsystem/Quest.cc	(revision 7354)
+++ code/branches/notifications/src/modules/questsystem/Quest.cc	(revision 7355)
@@ -367,5 +367,5 @@
         COUT(4) << "Quest {" << this->getId() << "} is failed for player: " << player << " ." <<std::endl;
 
-        this->getDescription()->sendFailQuestNotification();
+        this->getDescription()->sendFailQuestNotification(player);
         return true;
     }
@@ -386,5 +386,5 @@
         COUT(4) << "Quest {" << this->getId() << "} is completed for player: " << player << " ." <<std::endl;
 
-        this->getDescription()->sendCompleteQuestNotification();
+        this->getDescription()->sendCompleteQuestNotification(player);
         return true;
     }
@@ -412,5 +412,5 @@
         this->setStatus(player, QuestStatus::Active);
 
-        this->getDescription()->sendAddQuestNotification();
+        this->getDescription()->sendAddQuestNotification(player);
         return true;
     }
Index: code/branches/notifications/src/modules/questsystem/QuestDescription.cc
===================================================================
--- code/branches/notifications/src/modules/questsystem/QuestDescription.cc	(revision 7354)
+++ code/branches/notifications/src/modules/questsystem/QuestDescription.cc	(revision 7355)
@@ -84,10 +84,10 @@
     @param status
         The status the QuestDescription us for.
+    @param player
+        The player the Notification is sent to.
     @return
         Returns true if successful.
-    @todo
-        Make sure the messages meet the conditions.
     */
-    bool QuestDescription::notificationHelper(const std::string & item, const std::string & status)
+    bool QuestDescription::notificationHelper(const std::string & item, const std::string & status, PlayerInfo* player)
     {
         std::string message;
@@ -123,5 +123,5 @@
 
         QuestNotification* notification = new QuestNotification(this, message);
-        notification->send();
+        notification->send(player);
         return true;
     }
Index: code/branches/notifications/src/modules/questsystem/QuestDescription.h
===================================================================
--- code/branches/notifications/src/modules/questsystem/QuestDescription.h	(revision 7354)
+++ code/branches/notifications/src/modules/questsystem/QuestDescription.h	(revision 7355)
@@ -95,29 +95,33 @@
             /**
             @brief Sends a Notification displaying that a QuestHint was added.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendAddHintNotification(void)
-                { return notificationHelper("hint", ""); }
+            inline bool sendAddHintNotification(PlayerInfo* player)
+                { return notificationHelper("hint", "", player); }
 
             /**
             @brief Sends a Notification displaying that a Quest was added.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendAddQuestNotification(void)
-                { return notificationHelper("quest", "start"); }
+            inline bool sendAddQuestNotification(PlayerInfo* player)
+                { return notificationHelper("quest", "start", player); }
 
             /**
             @brief Sends a Notification displaying that a Quest was failed.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendFailQuestNotification(void)
-                { return notificationHelper("quest", "fail"); }
+            inline bool sendFailQuestNotification(PlayerInfo* player)
+                { return notificationHelper("quest", "fail", player); }
 
             /**
             @brief Sends a Notification displaying that a Quest was completed.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendCompleteQuestNotification(void)
-                { return notificationHelper("quest", "complete"); }
+            inline bool sendCompleteQuestNotification(PlayerInfo* player)
+                { return notificationHelper("quest", "complete", player); }
 
         private:
@@ -127,5 +131,5 @@
             std::string completeMessage_; //!< The message displayed when the Quest is completed.
 
-            bool notificationHelper(const std::string & item, const std::string & status); //!< Helper for sending QuestDescriptions as Notifications.
+            bool notificationHelper(const std::string & item, const std::string & status, PlayerInfo* player); //!< Helper for sending QuestDescriptions as Notifications.
 
             /**
Index: code/branches/notifications/src/modules/questsystem/QuestHint.cc
===================================================================
--- code/branches/notifications/src/modules/questsystem/QuestHint.cc	(revision 7354)
+++ code/branches/notifications/src/modules/questsystem/QuestHint.cc	(revision 7355)
@@ -121,5 +121,5 @@
                 this->playerStatus_[player] = QuestHintStatus::Active;
 
-                this->getDescription()->sendAddHintNotification();
+                this->getDescription()->sendAddHintNotification(player);
                 return true;
             }
Index: code/branches/notifications/src/modules/questsystem/QuestNotification.cc
===================================================================
--- code/branches/notifications/src/modules/questsystem/QuestNotification.cc	(revision 7354)
+++ code/branches/notifications/src/modules/questsystem/QuestNotification.cc	(revision 7355)
@@ -29,4 +29,5 @@
 #include "QuestNotification.h"
 #include "core/CoreIncludes.h"
+#include "infos/PlayerInfo.h"
 
 namespace orxonox {
@@ -68,10 +69,12 @@
     @brief
         Send the QuestNotification.
+    @param player
+        The player the Notification is sent to.
     @return
         Returns true if successful.
     */
-    bool QuestNotification::send(void)
+    bool QuestNotification::send(PlayerInfo* player)
     {
-        return true;//this->Notification::send(QuestNotification::SENDER); //TODO: Adjust.
+        return this->Notification::send(player->getClientID(), QuestNotification::SENDER);
     }
 
Index: code/branches/notifications/src/modules/questsystem/QuestNotification.h
===================================================================
--- code/branches/notifications/src/modules/questsystem/QuestNotification.h	(revision 7354)
+++ code/branches/notifications/src/modules/questsystem/QuestNotification.h	(revision 7355)
@@ -50,5 +50,5 @@
             virtual ~QuestNotification(); //!< Destructor.
 
-            bool send(void); //!< Send the QuestNotification.
+            bool send(PlayerInfo* player); //!< Send the QuestNotification.
 
         private: