Index: code/branches/notifications/data/gui/scripts/KeyBindMenu.lua
===================================================================
--- code/branches/notifications/data/gui/scripts/KeyBindMenu.lua	(revision 7357)
+++ code/branches/notifications/data/gui/scripts/KeyBindMenu.lua	(revision 7358)
@@ -113,5 +113,5 @@
         return "Joystick " .. name
     elseif( string.find(group, "JoyStickAxes") ~= nil ) then
-        return "Joystick Axis" .. string.sub(name, 5, 6) .. string.sub(name, string.find(name, 'Axis%d%d(.*)')+6)
+        return "Joystick Axis " .. string.sub(name, 5, 6) .. string.sub(name, string.find(name, 'Axis%d%d(.*)')+6)
     elseif( group == "MouseAxes" ) then
         return "Mouse " .. string.sub(name, string.find(name, '.(.*)')+1) .. " " .. string.sub(name, 1, 1) .. "-Axis"
Index: code/branches/notifications/data/levels/tutorial.oxw
===================================================================
--- code/branches/notifications/data/levels/tutorial.oxw	(revision 7357)
+++ code/branches/notifications/data/levels/tutorial.oxw	(revision 7358)
@@ -19,5 +19,5 @@
   >
 
-      <CommandNotification preMessage="Press '" postMessage="' to fire your primary weapon." command="fire 0">
+      <CommandNotification preMessage="Move '" postMessage="' to look left." command="scale 1 rotateYaw">
         <events>
             <trigger>
Index: code/branches/notifications/src/modules/notifications/dispatchers/CommandNotification.cc
===================================================================
--- code/branches/notifications/src/modules/notifications/dispatchers/CommandNotification.cc	(revision 7357)
+++ code/branches/notifications/src/modules/notifications/dispatchers/CommandNotification.cc	(revision 7358)
@@ -38,4 +38,5 @@
 #include "core/input/KeyBinderManager.h"
 #include "core/input/KeyBinder.h"
+#include "util/SubString.h"
 
 #include <sstream>
@@ -88,9 +89,39 @@
         std::stringstream stream;
         stream << this->getPreMessage();
-        //TODO: Add niceifyer.
-        stream << KeyBinderManager::getInstance().getCurrent()->getBinding(this->getCommand());
+        stream << this->bindingNiceifyer(KeyBinderManager::getInstance().getCurrent()->getBinding(this->getCommand()));
         stream << this->getPostMessage();
-        std::string* message = new std::string(stream.str());
-        return *message;
+        return *(new std::string(stream.str()));
+    }
+
+    /**
+    @brief
+        Transforms the input binding into a human readable form.
+    @param binding
+        The binding to be transformed
+    @return
+        Returns a human readable version of the input binding.
+    */
+    const std::string& CommandNotification::bindingNiceifyer(const std::string& binding)
+    {
+        SubString* string = new SubString(binding, '.');
+        std::string name = string->getString(1);
+        std::string group = string->getString(0);
+
+        std::stringstream stream;
+        if(group.compare("Keys") == 0)
+            stream << "Key " << name.substr(3);
+        else if(group.compare("MouseButtons") == 0)
+            stream << "Mouse " << name;
+        else if(group.compare("JoyStickButtons") == 0)
+            stream << "Joystick " << name;
+        else if(group.compare("JoyStickAxes") == 0)
+            stream << "Joystick Axis" << name.substr(5, 6) << name.substr(name.find("Axis")+6);
+        else if(group.compare("MouseAxes") == 0)
+            stream << "Mouse " << name.substr(1,3) << " " << name.substr(0, 1) << "-Axis";
+        else
+            stream << binding;
+
+        delete string;
+        return *(new std::string(stream.str()));
     }
     
Index: code/branches/notifications/src/modules/notifications/dispatchers/CommandNotification.h
===================================================================
--- code/branches/notifications/src/modules/notifications/dispatchers/CommandNotification.h	(revision 7357)
+++ code/branches/notifications/src/modules/notifications/dispatchers/CommandNotification.h	(revision 7358)
@@ -104,4 +104,6 @@
                  { this->postMessage_ = message; }
 
+            const std::string& bindingNiceifyer(const std::string& binding);
+
     };
 