Index: code/branches/doc/doc/api/Groups.dox
===================================================================
--- code/branches/doc/doc/api/Groups.dox	(revision 7362)
+++ code/branches/doc/doc/api/Groups.dox	(revision 7363)
@@ -64,10 +64,10 @@
 
 /**
-    @defgroup Events Events
+    @defgroup Input Input
     @ingroup Core
 */
 
 /**
-    @defgroup Input Input
+    @defgroup Management Management
     @ingroup Core
 */
Index: code/branches/doc/src/libraries/core/BaseObject.h
===================================================================
--- code/branches/doc/src/libraries/core/BaseObject.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/BaseObject.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup BaseObject BaseObject
+    @ingroup Core
+*/
+
+/**
     @file
+    @ingroup BaseObject
     @brief Definition of the BaseObject class.
 
Index: code/branches/doc/src/libraries/core/ClassFactory.h
===================================================================
--- code/branches/doc/src/libraries/core/ClassFactory.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ClassFactory.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Object Factory
     @brief Definition and implementation of the ClassFactory class
 
Index: code/branches/doc/src/libraries/core/ClassTreeMask.h
===================================================================
--- code/branches/doc/src/libraries/core/ClassTreeMask.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ClassTreeMask.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Class
     @brief Definition of the ClassTreeMask, ClassTreeMaskNode and ClassTreeMaskIterator classes.
 
Index: code/branches/doc/src/libraries/core/CommandLineParser.h
===================================================================
--- code/branches/doc/src/libraries/core/CommandLineParser.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/CommandLineParser.h	(revision 7363)
@@ -28,5 +28,5 @@
 
 /**
-    @defgroup CmdArgs Commandline Arguments
+    @defgroup CmdArgs Commandline arguments
     @ingroup Config
     @brief For a reference of all commandline arguments see @ref cmdargspage
Index: code/branches/doc/src/libraries/core/ConfigFileManager.h
===================================================================
--- code/branches/doc/src/libraries/core/ConfigFileManager.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ConfigFileManager.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Config ConfigFile
+*/
 
 #ifndef _ConfigFileManager_H__
Index: code/branches/doc/src/libraries/core/ConfigValueContainer.h
===================================================================
--- code/branches/doc/src/libraries/core/ConfigValueContainer.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ConfigValueContainer.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Config ConfigFile
     @brief Definition of the ConfigValueContainer class.
 
Index: code/branches/doc/src/libraries/core/ConfigValueIncludes.h
===================================================================
--- code/branches/doc/src/libraries/core/ConfigValueIncludes.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ConfigValueIncludes.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup ConfigFile Config file
+    @ingroup Config
+*/
+
+/**
 @file
+@ingroup Config ConfigFile
 @brief
     Definition of macros and functions for config-values.
Index: code/branches/doc/src/libraries/core/Core.h
===================================================================
--- code/branches/doc/src/libraries/core/Core.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Core.h	(revision 7363)
@@ -27,4 +27,14 @@
  *
  */
+
+/**
+    @defgroup CoreGame Core and Game
+    @ingroup Management
+*/
+
+/**
+    @file
+    @ingroup Management CoreGame
+*/
 
 #ifndef _Core_H__
Index: code/branches/doc/src/libraries/core/CoreIncludes.h
===================================================================
--- code/branches/doc/src/libraries/core/CoreIncludes.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/CoreIncludes.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup Factory RegisterObject() and CreateFactory()
+    @ingroup Object
+*/
+
+/**
     @file
+    @ingroup Object Factory
     @brief Definition of macros for Identifiers
 
Index: code/branches/doc/src/libraries/core/DynLib.h
===================================================================
--- code/branches/doc/src/libraries/core/DynLib.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/DynLib.h	(revision 7363)
@@ -29,4 +29,9 @@
 
 // 08/11/2009: Small adjustments for Orxonox by Fabian 'x3n' Landau
+
+/**
+    @file
+    @ingroup Management CoreGame
+*/
 
 #ifndef _Core_DynLib_H__
Index: code/branches/doc/src/libraries/core/DynLibManager.h
===================================================================
--- code/branches/doc/src/libraries/core/DynLibManager.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/DynLibManager.h	(revision 7363)
@@ -29,4 +29,9 @@
 
 // 08/11/2009: Small adjustments for Orxonox by Fabian 'x3n' Landau
+
+/**
+    @file
+    @ingroup Management CoreGame
+*/
 
 #ifndef _Core_DynLibManager_H__
Index: code/branches/doc/src/libraries/core/Event.h
===================================================================
--- code/branches/doc/src/libraries/core/Event.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Event.h	(revision 7363)
@@ -26,4 +26,14 @@
  *
  */
+
+/**
+    @defgroup Event Events
+    @ingroup Core
+*/
+
+/**
+    @file
+    @ingroup Event
+*/
 
 #ifndef _Event_H__
Index: code/branches/doc/src/libraries/core/EventIncludes.h
===================================================================
--- code/branches/doc/src/libraries/core/EventIncludes.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/EventIncludes.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Event
+*/
 
 #ifndef _EventIncludes_H__
Index: code/branches/doc/src/libraries/core/GUIManager.h
===================================================================
--- code/branches/doc/src/libraries/core/GUIManager.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/GUIManager.h	(revision 7363)
@@ -27,4 +27,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Graphics
+*/
 
 #ifndef _GUIManager_H__
Index: code/branches/doc/src/libraries/core/Game.h
===================================================================
--- code/branches/doc/src/libraries/core/Game.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Game.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
 @file
+@ingroup Management CoreGame
 @brief
     Declaration of Game Singleton.
Index: code/branches/doc/src/libraries/core/GameMode.h
===================================================================
--- code/branches/doc/src/libraries/core/GameMode.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/GameMode.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Management CoreGame
     @brief Declaration of the GameMode class.
 */
Index: code/branches/doc/src/libraries/core/GameState.h
===================================================================
--- code/branches/doc/src/libraries/core/GameState.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/GameState.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
 @file
+@ingroup Management CoreGame
 @brief
     Definition of GameState class.
Index: code/branches/doc/src/libraries/core/GraphicsManager.h
===================================================================
--- code/branches/doc/src/libraries/core/GraphicsManager.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/GraphicsManager.h	(revision 7363)
@@ -29,5 +29,11 @@
 
 /**
+    @defgroup Graphics Graphics and GUI
+    @ingroup Core
+*/
+
+/**
 @file
+@ingroup Graphics
 @brief
     Declaration of GraphicsManager Singleton.
Index: code/branches/doc/src/libraries/core/Identifier.h
===================================================================
--- code/branches/doc/src/libraries/core/Identifier.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Identifier.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup Identifier Identifier
+    @ingroup Class
+*/
+
+/**
     @file
+    @ingroup Class Identifier
     @brief Definition of the Identifier class, definition and implementation of the ClassIdentifier class.
 
Index: code/branches/doc/src/libraries/core/Iterator.h
===================================================================
--- code/branches/doc/src/libraries/core/Iterator.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Iterator.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Object ObjectList
     @brief Definition and implementation of the Iterator class.
 
Index: code/branches/doc/src/libraries/core/Language.h
===================================================================
--- code/branches/doc/src/libraries/core/Language.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Language.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup Language Language
+    @ingroup Core
+*/
+
+/**
     @file
+    @ingroup Language
     @brief Definition of the Language and the LanguageEntry class.
 
Index: code/branches/doc/src/libraries/core/Loader.h
===================================================================
--- code/branches/doc/src/libraries/core/Loader.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Loader.h	(revision 7363)
@@ -26,4 +26,14 @@
  *
  */
+
+/**
+    @defgroup Loader Loader
+    @ingroup XML
+*/
+
+/**
+    @file
+    @ingroup XML Loader
+*/
 
 #ifndef _Loader_H__
Index: code/branches/doc/src/libraries/core/LuaState.h
===================================================================
--- code/branches/doc/src/libraries/core/LuaState.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/LuaState.h	(revision 7363)
@@ -27,4 +27,14 @@
  *
  */
+
+/**
+    @defgroup Lua Lua
+    @ingroup Core
+*/
+
+/**
+    @file
+    @ingroup Lua
+*/
 
 #ifndef _LuaState_H__
Index: code/branches/doc/src/libraries/core/MemoryArchive.h
===================================================================
--- code/branches/doc/src/libraries/core/MemoryArchive.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/MemoryArchive.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Management Resources
+*/
 
 #ifndef _MemoryArchive_H__
Index: code/branches/doc/src/libraries/core/MetaObjectList.h
===================================================================
--- code/branches/doc/src/libraries/core/MetaObjectList.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/MetaObjectList.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Object ObjectList
     @brief Definition of the MetaObjectList class.
 
Index: code/branches/doc/src/libraries/core/Namespace.h
===================================================================
--- code/branches/doc/src/libraries/core/Namespace.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Namespace.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup XML Loader
+*/
 
 #ifndef _Namespace_H__
Index: code/branches/doc/src/libraries/core/NamespaceNode.h
===================================================================
--- code/branches/doc/src/libraries/core/NamespaceNode.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/NamespaceNode.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup XML Loader
+*/
 
 #ifndef _NamespaceNode_H__
Index: code/branches/doc/src/libraries/core/ObjectList.h
===================================================================
--- code/branches/doc/src/libraries/core/ObjectList.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ObjectList.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup ObjectList Object-lists and iterators
+    @ingroup Object
+*/
+
+/**
     @file
+    @ingroup Object ObjectList
     @brief Definition and implementation of the ObjectList class.
 
Index: code/branches/doc/src/libraries/core/ObjectListBase.h
===================================================================
--- code/branches/doc/src/libraries/core/ObjectListBase.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ObjectListBase.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Object ObjectList
     @brief Definition of the ObjectListBase class.
 
Index: code/branches/doc/src/libraries/core/ObjectListIterator.h
===================================================================
--- code/branches/doc/src/libraries/core/ObjectListIterator.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ObjectListIterator.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Object ObjectList
     @brief Definition and implementation of the Iterator class.
 
Index: code/branches/doc/src/libraries/core/OrxonoxClass.h
===================================================================
--- code/branches/doc/src/libraries/core/OrxonoxClass.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/OrxonoxClass.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup OrxonoxClass OrxonoxClass
+    @ingroup Class
+*/
+
+/**
     @file
+    @ingroup Class OrxonoxClass
     @brief Declaration of the OrxonoxClass Class.
 
Index: code/branches/doc/src/libraries/core/PathConfig.h
===================================================================
--- code/branches/doc/src/libraries/core/PathConfig.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/PathConfig.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Management Resources
+*/
 
 #ifndef _PathConfig_H__
Index: code/branches/doc/src/libraries/core/Resource.h
===================================================================
--- code/branches/doc/src/libraries/core/Resource.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Resource.h	(revision 7363)
@@ -26,4 +26,14 @@
  *
  */
+
+/**
+    @defgroup Resources Resources
+    @ingroup Management
+*/
+
+/**
+    @file
+    @ingroup Management Resources
+*/
 
 #ifndef _Core_Resource_H__
Index: code/branches/doc/src/libraries/core/SmartPtr.h
===================================================================
--- code/branches/doc/src/libraries/core/SmartPtr.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/SmartPtr.h	(revision 7363)
@@ -28,4 +28,14 @@
 
 // Inspired by boost::intrusive_ptr by Peter Dimov
+
+/**
+    @defgroup SmartPtr SmartPtr<T> and WeakPtr<T>
+    @ingroup Object
+*/
+
+/**
+    @file
+    @ingroup Object SmartPtr
+*/
 
 #ifndef _SmartPtr_H__
Index: code/branches/doc/src/libraries/core/SubclassIdentifier.h
===================================================================
--- code/branches/doc/src/libraries/core/SubclassIdentifier.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/SubclassIdentifier.h	(revision 7363)
@@ -29,4 +29,5 @@
 /**
     @file
+    @ingroup Class Identifier
     @brief Definition of SubclassIdentifier.
 
Index: code/branches/doc/src/libraries/core/Super.h
===================================================================
--- code/branches/doc/src/libraries/core/Super.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Super.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup Super Super
+    @ingroup Class
+*/
+
+/**
     @file
+    @ingroup Class Super
     @brief Definition of all super-function related macros.
 
Index: code/branches/doc/src/libraries/core/Template.h
===================================================================
--- code/branches/doc/src/libraries/core/Template.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Template.h	(revision 7363)
@@ -26,4 +26,14 @@
  *
  */
+
+/**
+    @defgroup Template Template
+    @ingroup XML
+*/
+
+/**
+    @file
+    @ingroup XML Template
+*/
 
 #ifndef _Template_H__
Index: code/branches/doc/src/libraries/core/Thread.h
===================================================================
--- code/branches/doc/src/libraries/core/Thread.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/Thread.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup ThreadPool
+*/
 
 #ifndef _Thread_H__
Index: code/branches/doc/src/libraries/core/ThreadPool.h
===================================================================
--- code/branches/doc/src/libraries/core/ThreadPool.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ThreadPool.h	(revision 7363)
@@ -26,4 +26,14 @@
  *
  */
+
+/**
+    @defgroup ThreadPool Thread pool
+    @ingroup Core
+*/
+
+/**
+    @file
+    @ingroup ThreadPool
+*/
 
 #ifndef _ThreadPool_H__
Index: code/branches/doc/src/libraries/core/ToluaInterface.h
===================================================================
--- code/branches/doc/src/libraries/core/ToluaInterface.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/ToluaInterface.h	(revision 7363)
@@ -29,4 +29,6 @@
 /**
 @file
+@ingroup Lua
+@brief
     This is required because tolua would parse this macro in LuaState.h and fail
 */
Index: code/branches/doc/src/libraries/core/WeakPtr.h
===================================================================
--- code/branches/doc/src/libraries/core/WeakPtr.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/WeakPtr.h	(revision 7363)
@@ -28,4 +28,9 @@
 
 // Inspired by boost::intrusive_ptr by Peter Dimov
+
+/**
+    @file
+    @ingroup Object SmartPtr
+*/
 
 #ifndef _WeakPtr_H__
Index: code/branches/doc/src/libraries/core/WindowEventListener.h
===================================================================
--- code/branches/doc/src/libraries/core/WindowEventListener.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/WindowEventListener.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup Graphics
+*/
 
 #ifndef _WindowEventListener_H__
Index: code/branches/doc/src/libraries/core/XMLFile.h
===================================================================
--- code/branches/doc/src/libraries/core/XMLFile.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/XMLFile.h	(revision 7363)
@@ -26,4 +26,9 @@
  *
  */
+
+/**
+    @file
+    @ingroup XML XMLPort
+*/
 
 #ifndef _XMLFile_H__
Index: code/branches/doc/src/libraries/core/XMLNameListener.h
===================================================================
--- code/branches/doc/src/libraries/core/XMLNameListener.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/XMLNameListener.h	(revision 7363)
@@ -27,4 +27,9 @@
  */
 
+/**
+    @file
+    @ingroup XML XMLPort
+*/
+
 #ifndef _XMLNameListener_H__
 #define _XMLNameListener_H__
Index: code/branches/doc/src/libraries/core/XMLPort.h
===================================================================
--- code/branches/doc/src/libraries/core/XMLPort.h	(revision 7362)
+++ code/branches/doc/src/libraries/core/XMLPort.h	(revision 7363)
@@ -28,5 +28,11 @@
 
 /**
+    @defgroup XMLPort XMLPort
+    @ingroup XML
+*/
+
+/**
     @file
+    @ingroup XML XMLPort
     @brief Declaration of the XMLPort helper classes and macros.
 